--gameManager.lua 

--[[ this file handles input and game rules 

. Game Manager


Init (display gameboard, initial rocks, initial player)

main loop
do
Process Player Input
Update Rocks (new rocks fall ?)
Update Player (decrease health)
until done

Actions
Change Direction
Move (left/right)
 Move player, check for collisions with adjacent rocks
Jump (left, right)
 Move player left/right,
 jump up depending on strength and carrying rock weight height
 land on rock

Grab Rock
 based on direction
 grab rock and set as held if strength enough for weight

Lift Rock
 move held rock up if stength enough
 update rock adjacent data

Drop Rock
 drop held rock (mark rock as dropping so can animate rock position)
 update rock adjacent data if lands on rock
 clear held status

Slam Rock
 set rock slam animation
 destroy rock

Kick Rock
 move rock in direction

Break Out
--]]

--[[ I'm not sure why we need this do file here. All I can say is .. something isn't working right. Yet.
dofile("player.lua")
dofile("rock.lua")
dofile("assets.lua")
--]]
GM = {} 

-- base love functions I'm not sure I need them. It makes sense as a table going into the main file
function GM:load() 

-- This function can actually have a use . We can load different scenes based on the game state.. But.. In this case the game is too small to care. 

end 

function GM:update(dt) 


--[[
Main Game Logic resides here! Pay attention!  

- Check input. 
- Enforce Rules. 
- Display.
- Repeat

--]]

	GM:checkInput()
	GM:checkRules() -- is the player progressing? How do we adjust the score? Combos? Win? Lose? It's all in here. 
	GM:updateGravity()
	-- part of the house keeping to get ready for the next round.

end 

function GM:draw() 
 -- the best guess for now is that we need functions like these so that we don't get a nil back when we add it to the table. 
end 

-- engine Functinality
-- GM:checkRocks() -- keeps the rocks in a 7x7 grid formation ( or spacial array )

function GM:checkInput()

	-- xan normally walks toward the mouse pointer
	-- so we modify the scale to flip all animations when the mouse is on either side. 
	
	
	-- flip player scale. 
	if mx < xan.x then xan.sx = -1 
	elseif mx > xan.x then xan.sx = 1
	end 
	
		
	-- Move Player Left and right 
	if checkHit(mouseHelper, xan) == false and xan.footBlocked and my < xan.y then 
		
		xan:Walk() -- set's the state. 
		xan.vX = xan.vX + xan.speed * xan.sx -- increment velocity by speed and dir. 
		xan.x = xan.x + xan.vX -- apply to position
		
		-- Clamp Player Velocity
		if xan.vX >= xan.maxSpeed then -- this is the kind of thing that the player can handle. 
			xan.vX = xan.maxSpeed
			-- do you know why this won't work both ways?  E + W
		end 
		
		if xan.vX <= (xan.maxSpeed*-1) then 
			xan.vX = (xan.maxSpeed*-1) -- because a  proper clamp looks simi
		end 
		
		--Finally it takes a little stamina to move around. 
		pStamina = pStamina - 0.1 

	else  -- slow the player to a stop 
	
		-- maybe There should be a state for no Input. If the mouse hasn't moved and the buttons aren't pressed. 
		-- I want to scale the velocity down. So the player slows to a stop. Ease in a little. 
		--xan:Idle() -- is this the only place? 
		xan.vX = 0  -- can subtract. Dividing down to zero is plain strange.  
		
		
	end 
		--- Crouch Controls. 
	if my > xan.y and xan.footBlocked then 
	
		xan:Crouch()
	
	end 
	
	-- Kick Control. 
	if xan.state == "crouch" and love.mouse.isDown('r') then 
		
		-- if getTargetRock(--return rocks[id == number]).canKick then
		-- targetRock:Slide(e/w)
		xan:KickRock()
		
	
	end 
	
	-- What happens when we extend the use of the mouse helper? 
	-- STAMINA BAR> needs a game timer. 
	
	-- Grab Control
	if love.mouse.isDown('r') and xan.footBlocked and xan.state ~= "crouch" and xan.state ~= "kick" then 
		
		xan:GrabRock() -- sets the player animation. 
		
		-- I only want it to take 30 stamina per press. So I have to manage the animation. 
		-- Also I have to make sure to clamp the player Stamina
		if didGrab == false then 
			pStamina = pStamina - 30
			didGrab = true -- one time trigger? 
		end 
		
		
		
	end
	


	-- Jump 
	if love.mouse.isDown('l') and xan.footBlocked then -- if xan is standing and left click is pressed. 
		
		
	 if didJump == false then --I want to launch the jump routine. In a clean fashion. 
		if GM.canJump() then  
		
			xan:Jump()-- always set player state first. So he appears to do it! Assets willing.
			didJump = true
		-- do you have to do it a million times a second?  Think smoother. 		
			xan.vY = xan.vY - xan.jacl
			 
			 -- we need to use the jump speed max to clamp the vertical accel. 
			 
			if xan.vY >= xan.jsmx then 
			 
				xan.vY = xan.jsmx
				
			end 
		
		
		
		else 

			-- we need to move the player back down. 
			xan.vY = xan.vY + grav -- al little weak. 
		
		
		end 
	 end 
		
		-- update the player velocity no matter what. ( adjustments to this should be made before ) 
		
		xan.y = xan.y + xan.vY 
		
	end 
	

	
	
	-- Slam Control
	
	-- Break out Control
	
	-- I'm going to Guess that the IDLE State should be determined last. Rule out all others first. 
	
	-- No Action at all requires the idle Idle State. 
	if checkHit(xan,mouseHelper) and mouseHelper.state == "no" then 
		xan:Idle()
	end
	
end 

-- Maybe I should use a function to check the jump height. 

function GM:canJump() -- right now this is being set too often. 

	-- we need to determine that the player hasn't jumped already. 
	if xan.y <= xan.jhgt 
		or didJump == true 
		or xan.footBlocked == false then 
	
		return false 
	
	else 
	
		return true
	
	end 
	

end 

function love.mousereleased(x, y, btn)

	if btn == 'l' then 
	test = "left does it "
		if didJump then 
			didJump = false 
		end
		-- probably want to reset the jump animation.
	end 
	
	if btn == 'r' then 
	test = "right does it "
		if didGrab then 
			didGrab = false 	
		end 
	-- reset kick animation
	xanKick:seek(1)
	end
	

	
	
end 

function love.mousereleased(mx,my, l)

	if didJump then 
		didJump = false -- this technique is the double jump. or you can use a counter. 
		test = "left does it" 
	end 

end

--Game Rules. Points .. it's all inside. This is the "fun" part. I think the real fun is defining lines of expression. Drawing with ideas you know. 
function GM:checkRules() 

	-- if the stamina runs out.. let's see how that looks. 
	
	if pStamina <= 0 then 
		
		pStamina = 0 
		gameState = "gameOver"
	
	end
	

end

-- The following code is housekeeping. Make the game look natural. Make sense even. 
function GM:updateGravity() 

	xan.y = xan.y + grav -- hack. Figure out why the below code doesn't work. 
	
	--if the player is in the air
	if xan.y < groundLevel and footBlocked == false then
		xan.state = "land"
		xan.vX = 0
		xan.y = xan.y + grav
		
	end
	
	if xan.y >= groundLevel then 
		
		xan.footBlocked = true
		xan.y = groundLevel
	
	end 

	
	-- ROCKS ARE AFFECTED
	for i,v in ipairs ( rocks ) do 
	    -- at what rate do we need to check the rocks? 
		-- for now this is where it all goes down. 

		v:Drop() -- on the one hand I have the rock state that I can manipulate. Also there is the  
		
		if v.y >= groundLevel then 
		
			v.y = groundLevel
		
		end 
	
	end 

end 

function GM:createRock() -- add x,y so we can make the rocks in any location. 

	-- right now should only make small rocks. 
	-- The idea is we modify the id number.So we can get to it later. 
	rockId = rockId + 1
	table.insert(rocks,newRock(mx, my,1)) -- change to input args. 

end 

-- GM Actions just like DND -- game rule functionality


function GM:addRocks()

-- Creates a "level" a new set of rocks. 


end 

function GM:addPoints()

-- triggered to modify the score when the player destroys a rock. 

end 
-- the GM will handle things like gravity.