-- player.lua 

--[[

Player
Attributes: position, health/stamina,
holding rock,
Rocks on Player
other ? 
Actions (see player actions)


2. Player actions
Move (left/right)
Jump (left, right)
Grab Rock
Lift Rock
Drop Rock
Slam Rock
Kick Rock
Break Out



--]]

xan = {}

xan = {     
		x = lg.getWidth()/5 , -- based on screen size start on the left 
		y = lg.getHeight()/2, -- init position
		vX = 0.0, -- Velocity
		vY = 0.0, 
		rot= 0, -- draw vars
		sx = 1,
		sy = 1,
		xo = 64, -- offset from origin. 
		yo = 115,
		
		speed= 0.25, -- default 0.25 Has a kinda slow start--Config Vars (speed == velX, jspd = velY .. REMEMBR IT!
		maxSpeed = 5, 
		jspd = 0, -- to be incremented by accel. and decremented by gravity. 
		aspd = 10, -- airspeed
		str = 1, -- starting Strength
		jsmx = 20, -- the maximum speed of jumps
		jhgt = 150,
		jacl = 1,
		frict = 1, -- need to slow the player down. 
		
		state = "idle", --Default States
		facing = "right",
		strength = 1, -- has to be equal to weight of rocks to lift
		
		footBlocked = false
		
	}

-- base love functions
function xan:load() 


end 

function xan:update (dt) 

	xan:checkFacing()
	xan:checkFootBlock()
	
	-- move the player Based on velocity 
	-- xan.y = xan.y + xan.vY

-- Animation Switch
	if xan.state == "idle" then 
	
		xanIdle:update(dt) 
		
	elseif xan.state == "walk" then
	
		xanWalk:update(dt) 
		
	elseif xan.state == "crouch" then
	
		xanCrouch:update(dt) 
		
	elseif xan.state == "grab" then
	
		xanGrab:update(dt) 
		
	elseif xan.state == "jump" then
	
		xanJump:update(dt) 
		
	elseif xan.state == "kick" then
	
		xanKick:update(dt) 
		
	elseif xan.state == "land" then
	
		xanLand:update(dt) 
		
	end

end 

function xan:draw() 

	if xan.state == "crouch" then
		xanCrouch:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo)
	elseif xan.state == "grab" then
		xanGrab:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo)
	elseif xan.state == "idle" then    --- this section actually is working with the animation switches. 
		xanIdle:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo)
	elseif xan.state == "walk" then
		xanWalk:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo)
	elseif xan.state == "jump" then
		xanJump:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo + 30)
	elseif xan.state == "fall" then
		xanLand:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo + 30) -- adjust for image size 
		xanLand:seek(1)
	elseif xan.state == "land" then
		xanLand:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo + 30) -- adjust for image size 
	elseif xan.state == "kick" then
		xanKick:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo ) -- adjust for image size 
	elseif xan.state == "slam" then
		xanSlam:draw(xan.x, xan.y, xan.rot, 
					 xan.sx, xan.sy, xan.xo, xan.yo ) -- adjust for image size 
	end

end 

-- player utilities ( private methods ) 

function xan:checkFacing() 

	if xan.sx == 1 then 
		xan.facing = "right"
	elseif xan.sx == -1 then 
		xan.facing = "left"
	end 
	
end 

function xan:checkFootBlock()

	if xan.y >= groundLevel then 
	
		xan.footBlocked = true
	
	else 
	
		xan.footBlocked = false
		
	end
		
	-- doesn't account for rocks at all. The GM should send that signal. In rock Collision 
	

end 


-- player Actions 
function xan:Walk() -- left and right 

	-- this is a good place to use xan facing 
	self.state = "walk"

end 

function xan:Crouch() 

	self.state = "crouch"
	

end 

function xan:Idle() 

	self.state = "idle" 

end 

function xan:Jump() -- left and right 

	self.state = "jump"
	
end 

function xan:Fall() -- it's a static frame one from land.

	self.state = "fall"

end

function xan:Land() 

	self.state = "land"

end 

function xan:GrabRock()

	self.state = "grab"
	-- somewhere in here I have to stop the grasp animation if the player comes in contact with a rock. Or is holding down the button. Multiple grabs look silly.  
	
end 

function xan:LiftRock() 

	self.state = "lift"
	
end 

function xan:DropRock() 

	self.state = "drop"
	
end 

function xan:SlamRock()

	self.state = "slam"
	
end 

function xan:KickRock()

	self.state = "kick"
	
end 

function xan:BreakOut() 

	self.state = "breakOut"
	
end 

